package info.textgrid.middleware;

import info.textgrid.middleware.oaipmh.ListSetsType;
import info.textgrid.middleware.oaipmh.SetType;
import info.textgrid.namespaces.middleware.tgcrud.common.TextGridMimetypes;
import info.textgrid.utils.sesameclient.SesameClient;


import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;

import org.elasticsearch.action.get.GetRequestBuilder;
import org.elasticsearch.action.get.GetResponse;
import org.elasticsearch.action.search.SearchRequestBuilder;
import org.elasticsearch.action.search.SearchResponse;
import org.elasticsearch.index.query.QueryBuilder;
import org.elasticsearch.index.query.QueryBuilders;
import org.elasticsearch.search.SearchHit;

public class SetDeliverer {

	private OAI_ESClient	oaiEsClient;
	private SesameClient sparqlClient;

	public SetDeliverer(OAI_ESClient oaiEsClient, boolean textgrid, boolean dariah) {
		this.oaiEsClient = oaiEsClient;
		this.textgrid = textgrid;
		this.dariah = dariah;
//		System.out.println(dariah);
	}

	private Set<String>	identifier			= new LinkedHashSet<String>();
    private String formatField;
    private String formatToFilter;
    private String identifierField;
    private String repositoryObjectURIPrefix;
    private String specField;
    private String specFieldPrefix;
    private Set<String> project	= new LinkedHashSet<String>();
    private static Map<String, String> setSet = new Hashtable<String, String >();
    private boolean textgrid;
    private boolean dariah;
    

	public ListSetsType setListBuilder() {
		//System.out.println("HALLO !!!!!!!!!!!!!!!!!!!");
//		System.out.println("DARIAH: " + dariah);
//		System.out.println("TEXTGRID: " + textgrid);
		ListSetsType setList = new ListSetsType();
		QueryBuilder aggQuery;
		//System.out.println("TEXTGRID: " + textgrid);
		if (textgrid) {		
			aggQuery = QueryBuilders.matchPhraseQuery("format",TextGridMimetypes.DARIAH_COLLECTION);
		}else{
//			System.out.println("JUHU");
			aggQuery = QueryBuilders.matchPhraseQuery("descriptiveMetadata.dc:format", TextGridMimetypes.DARIAH_COLLECTION);
		}
		
//		System.out.println(aggQuery);
		
		SearchRequestBuilder request = OAI_ESClient.getOaiESClient()
				.prepareSearch(OAI_ESClient.getEsIndex())
				.setTypes(OAI_ESClient.getEsType())
				.setQuery(aggQuery)
				.addField(formatField)
				.addField(identifierField)
				.addField("project.value")
				.addField("project.id")
				.setSize(100000); 
		
		//System.out.println("QUERY: " + request);
		
		SearchResponse getRecordListItems = request.execute().actionGet();
		//System.out.println(getRecordListItems);
		for (SearchHit hit : getRecordListItems.getHits().getHits()) {
			//System.out.println("HALLO HALLO");
			//if(hit.getFields().get(formatField) != null && hit.getFields().get(formatField).value().equals(formatToFilter)) {
				//System.out.println("IDENTIFIER FIELD: " + identifierField);
//				System.out.println("DARIAH SET");
				if(dariah == true && hit.getFields().get(identifierField).values().get(0).toString().startsWith("hdl:")){
//					System.out.println("JUHU");
					this.identifier.add(hit.getFields().get(identifierField).values().get(0).toString());
					
				}
				
				if(textgrid==true){
					//System.out.println("HALLO TEXTGRIT");
					String projectName = hit.getFields().get("project.value").values().get(0).toString();
				    String projectID = hit.getFields().get("project.id").values().get(0).toString();
					String projectSetSpec = projectName.concat(":").concat(projectID);

					this.setSet.put(projectID, projectName);

				}
			}
			

		//}
		
		if(textgrid==true){
//			System.out.println("HALLO GRIT");
			
			Iterator it = setSet.entrySet().iterator();
			
			while(it.hasNext()){
				Map.Entry pair = (Map.Entry)it.next();
				SetType set = new SetType();
				set.setSetName(pair.getValue().toString());				
				set.setSetSpec("project:" + pair.getKey().toString());				
				setList.getSet().add(set);
			}

		}

		if(dariah == true){
		for (String identifierSetSpec : this.identifier) {
			String id = identifierSetSpec;
			try {
				id = URLDecoder.decode(id, "UTF-8");				
			} catch (UnsupportedEncodingException e) {
				e.printStackTrace();
			}
			
			id = identifierSetSpec.substring(repositoryObjectURIPrefix.length());

			
			GetRequestBuilder collectionNameById = OAI_ESClient
					.getOaiESClient().prepareGet()
					.setIndex(OAI_ESClient.getEsIndex())
					.setType(OAI_ESClient.getEsType())
					.setFields(specField)
					.setId(id); 						

			GetResponse setSpec = collectionNameById.execute().actionGet();
				String setName = "";
				if(setSpec != null && setSpec.isExists()){
					if (setSpec.getField(specField) != null) {
						setName = setSpec.getField(specField).getValue().toString();
					}
				}
				SetType set = new SetType();

				set.setSetName(setName);
				set.setSetSpec(specFieldPrefix + id);
				setList.getSet().add(set);
			
				
		}
		}
		identifier.clear();
		return setList;

	}
	
	public String getFormatField() {
		return formatField;
	}
	public void setFormatField(String formatField) {
		this.formatField = formatField;
	}

	public String getFormatToFilter() {
		return formatToFilter;
	}

	public void setFormatToFilter(String formatToFilter) {
		this.formatToFilter = formatToFilter;
	}

	public String getIdentifierField() {
		return identifierField;
	}

	public void setIdentifierField(String identifierField) {
		this.identifierField = identifierField;
	}

	public String getRepositoryObjectURIPrefix() {
		return repositoryObjectURIPrefix;
	}

	public void setRepositoryObjectURIPrefix(String repositoryObjectURIPrefix) {
		this.repositoryObjectURIPrefix = repositoryObjectURIPrefix;
	}

	public String getSpecField() {
		return specField;
	}

	public void setSpecField(String titleField) {
		this.specField = titleField;
	}

	public String getSpecFieldPrefix() {
		return specFieldPrefix;
	}

	public void setSpecFieldPrefix(String specFieldPrefix) {
		this.specFieldPrefix = specFieldPrefix;
	}

	public boolean isTextgrid() {
		return textgrid;
	}

	public void setTextgrid(boolean textgrid) {
		this.textgrid = textgrid;
	}
	
	public boolean isDariah() {
		return dariah;
	}

	public void setDariah(boolean dariah) {
		this.dariah = dariah;
	}

	public SesameClient getSparqlClient() {
		return sparqlClient;
	}

	public void setSparqlClient(SesameClient sparqlClient) {
		this.sparqlClient = sparqlClient;
	}
}
